include win64a.inc
include msvcrt.inc
includelib gdi32.lib
includelib msvcrt.lib
IMAGE_BASE	equ 400000h
cdXPos          equ 131
cdYPos          equ 217
cdYSize         equ 430
cdXSize         equ 640

movr macro x,y
	mov x,0
	org $-4
	dd y
endm

.code


WndProc	proc hWnd:QWORD,Msg:QWORD,wParam:QWORD,lParam:QWORD

local ps:PAINTSTRUCT
local hdc:qword
local hOldBmp:qword
local hGDITmp:qword
local hOldDIB:qword
local hBackDC:qword
local hMainDIB:qword
local bufBMP:qword
local i:dword
local x:dword
local y:dword
local a:dword
local b:dword
local c:dword
local d:dword
local e:dword
local f:dword
local NewX:qword
local NewY:qword
local XCC:qword
local YCC:qword

	push	rbp
	mov	ebp, esp
	sub	esp,(50h+sizeof PAINTSTRUCT+11*8+9*4+15)and(-16)

	mov	hWnd,rcx
	cmp	edx, WM_DESTROY
	jz	wmDESTROY
        cmp	edx, WM_PAINT
	jz	wmPAINT
        cmp	edx, WM_CREATE
	jz	wmCREATE
	leave
        jmp	DefWindowProc
; ---------------------------------------------------------------------------
wmDESTROY::mov rdx,hOldBmp
	mov rcx,hBackDC
	call SelectObject
	mov hGDITmp,rax
	mov rcx,bufBMP
	call DeleteObject
	mov rcx,hBackDC
	call DeleteDC
	mov rdx,hOldDIB
	mov rcx,bufDIBDC
	call SelectObject
	mov hGDITmp,rax
	mov rcx,bufDIBDC
	call DeleteDC
	mov rcx,hMainDIB
	call DeleteObject
	mov rcx,hWnd
	call	DestroyWindow
	xor ecx,ecx		; nExitCode
	call	ExitProcess
; ---------------------------------------------------------------------------
wmPAINT:lea edx,ps
	call BeginPaint
	mov hdc,rax
	mov qword ptr [rsp+40h],SRCCOPY; rop
        xor edx,edx		; x
	mov [rsp+38h],rdx	; y1
	mov [rsp+30h],rdx	; x1
	mov rax,bufDIBDC	; hdcSrc
        mov [rsp+28h],rax
	mov rax,cdYSize
	mov [rsp+20h],rax
	mov r9,cdXSize		; cx
	xor r8d,r8d		; cy		
	mov rcx,hdc		; hdc
	call BitBlt
	lea edx,ps
	mov rcx,hWnd
	call EndPaint
	jmp wmBYE
; ---------------------------------------------------------------------------
wmCREATE:mov rcx,hWnd
	call GetDC
	mov hdc,rax
        mov rcx,rax		; HDC
	call CreateCompatibleDC
	mov bufDIBDC,rax

	mov [rsp+28h],rbx	
	mov [rsp+20h],rbx
	mov r9d,offset pMainDIB
	mov r8d,DIB_RGB_COLORS
	mov edx,offset bi
	mov rcx,hdc 
        call CreateDIBSection
	mov hMainDIB,rax
	mov rdx,rax; hMainDIB
	mov rcx,bufDIBDC
	call SelectObject
        mov rax,hOldDIB
	mov rdx,hdc
	mov rcx,hWnd          
        call ReleaseDC;   // Libera device context          
;Init--------------------------------------------------------
;0.935567 -0.164966 0.164966 0.935567  0     0    0.958*10000=9580
;0.1       0        0        0.1       0.75 -0.75 0.011*10000= 110
;0.1       0        0        0.1      -0.75  0.75 0.011*10000= 110
;0.1       0        0        0.1       0.75  0.75 0.011*10000= 110
;0.1       0        0        0.1      -0.75 -0.75 0.009*10000=  90

	mov XCC,rbx
	mov YCC,rbx

	mov i,390000
bucle:  call rand
	mov ecx,10000
	xor edx,edx
	div ecx
	cmp	edx,90
	jg	@f
	movr 	a,0.1                       
	mov 	b,ebx  
	mov 	c,ebx
	movr 	d,0.1      
	movr	e,-0.75 
	movr 	f,-0.75
	jmp	fin
@@:	cmp	edx,200
	jg	@f
	movr 	a,0.1                       
	mov 	b,ebx  
	mov 	c,ebx
	movr 	d,0.1       
	movr	e,0.75  
	movr 	f,0.75
	jmp	fin
@@:	cmp	edx,310
	jg	@f
	movr 	a,0.1                       
	mov 	b,ebx  
	mov 	c,ebx
	movr 	d,0.1      
	movr	e,-0.75  
	movr 	f,0.75
	jmp	fin
@@:	cmp	edx,420
	jg	@f
	movr 	a,0.1                       
	mov 	b,ebx  
	mov 	c,ebx
	movr 	d,0.1       
	movr	e,0.75 
	movr 	f,-0.75
	jmp	fin
@@:	movr 	a,0.935567 
	movr 	b,-0.164966 
	movr 	c,0.164966 
	movr 	d,0.935567       
	mov	e,ebx
	mov	f,ebx

fin:	fld	a       ;st(0) = a
	fmul	XCC     ;st(0) = a * XCC
	fld	b       ;st(0) = b
	fmul	YCC     ;st(0) = b * YCC
	faddp	        ;st(0) = a * XCC + b * YCC
        fadd	e       ;st(0) = a * XCC + b * YCC + e
	fst	NewX    ;NewX  = a * XCC + b * YCC + e
	fmul	Scale	;st(0) = NewX * 190
        fadd	ShiftX ;st(0) = NewX * 190 + 320
	fistp	x       ;x = (int) (NewX * 190 + 320)
        mov	eax,x
	cmp	eax,cdXSize 
	jae	@f
	fld 	c       ;st(0) = c
	fmul	XCC     ;st(0) = c * XCC
	fld	d       ;st(0) = d
	fmul	YCC     ;st(0) = d * YCC
	faddp	        ;st(0) = c * XCC + d * YCC
	fadd	f       ;st(0) = c * XCC + d * YCC + f
	fst	NewY    ;NewY  = c * XCC + d * YCC + f
	fst	YCC     ;YCC = NewY
	fmul	Scale;st(0) = NewY * 190
	fsubr	ShiftY;st(0)  = -NewY * 190 + 405
	fistp	y       ; y = (int) (-NewY * 190 + 405)
	mov	ecx, y
	cmp	ecx,cdYSize 
	jae	@f
	imul 	ecx,cdXSize*4
	add 	rcx,pMainDIB
	mov	dword ptr [rcx+rax*4],0FFFFFFh
@@:	fld	NewX  ;XCC = NewX
	fstp	XCC
	dec i
	jnz  bucle
wmBYE:	leave
	retn
WndProc	endp

WinMain	proc
local msg:MSG

	push rbp
	mov ebp,esp
	sub esp,sizeof MSG

		xor ebx,ebx
		mov esi,IMAGE_BASE
		mov edi,offset ClassName 
		push rbx		;hIconSm
		push rdi		;lpszClassName
		push rbx		;lpszMenuName
		push COLOR_WINDOWTEXT;	hbrBackground
		push rbx		;hCursor
		push rbx        	;hIcon
		push rsi		;hInstance
		push rbx        	;cbClsExtra & cbWndExtra
		db 68h
		dd WndProc      	;lpfnWndProc
		push sizeof WNDCLASSEX	;cbSize & style
		mov ecx,esp		;addr WNDCLASSEX
		call	RegisterClassEx
		push rbx
		push rsi		;rsi=400000h
		push rbx
		push rbx
		push cdYSize	
	push cdXSize	
	push cdYPos	
	push cdXPos
	mov r9d,WS_VISIBLE
	mov r8,rdi		;offset ClassName
	mov edx,edi		;offset ClassName
	xor ecx,ecx
	sub esp,20h		; dwExStyle
	call CreateWindowEx
@@:     lea ecx,msg
	xor edx,edx
	xor r8d,r8d
	xor r9d,r9d		
	call GetMessage
	cmp msg.wParam,VK_ESCAPE;user press 'Esc'?
	je wmDESTROY
	lea ecx,msg		
	call DispatchMessage
	jmp @b
WinMain	endp

.data
ClassName	db 'Spiral Fractal',0
bi BITMAPINFO <<28h,cdXSize,-cdXSize,1,32,0,0,0,0,0,0>>
bufDIBDC	dq ?
pMainDIB	dq ?
Scale	dd 190.0
ShiftX	dd 320.0		
ShiftY	dd 185.0
end